/////////////////////////////////////////////////////////////////////////////
//Doppelpendel ohne Reibung und ohne Schwerkraft mit Runge-Kutta 4 - Poincaré-Schnitt zu zeichnen
/////////////////////////////////////////////////////////////////////////////

// Attribute:
int n = 4;            // Anzahl der Variablen
float[] ZVaktuell = {3.14, 3.14, 0, 0}; // Initialisierung w1,w2,g1,g2
float w1,w2; //Winkel von der Senkrechten weg
float W1,W2; //Für Runge-Kutta verwendet: Winkel in Ruhelage: PI
float g1,g2; //Winkelgeschwindigkeiten
      
float dt = 0.1;      // Zeitschritt
//Lage der Massen
float masse1X ;
float masse1Y ;
float masse2X ;
float masse2Y ;
float masse;
float E; //Gesamtenergie mit Nullniveau in Ruhelage
float L = 180;
float G = 0;         // Ortfaktor für Schwerkraft
float ruhelage = 400;         // Ruhelag in x-Koordinate
float EKontrolleA;//Gesamtenergie 
float wK,gK; //Koordinaten der Bildpunkte
float D1,D2; //Diskriminaten für die Berechnung der fehlenden Winkelgeschwindigkeit bei gleicher Energie
color farbe;
int M,m, AnzahlStartpunkte;
float wVor,wNach;
ArrayList<PVector> punkte = new ArrayList<PVector>(); //Zum speichern der Kurvenpunkte
///////////////////////////////////////////////////////////////////////////
void setup() {
  size(800,500);
  background(0);
  masse =1;
  E= 500;
  M = 500;//Anzahl Folge-Punkte für einen Anfangspunkt
  AnzahlStartpunkte = 3;
  D1=D2=0;
  neuStarten();
 // EKontrolleA = masse*g1*g1*L*L +0.5*masse*g2*g2*L*L + masse*g1*g2*L*L*cos(w2-w1) - G*masse*L*(2*cos(w1)+cos(w2)-3);
  for(int j = 0; j<AnzahlStartpunkte;j++){
    folgePunkteBerechnen(); 
    println(j);//zeigt an, der wievielte Startpunkt verwendet wird
  }
}

/////////////////////////////////////////////////////////
void draw() { 
 
 
  
}

//////////////////////////////////////////////////////////
float[] ZVentwickeln(float[] Y) {
    float[] ZustandsVektor = new float[n]; 
    ZustandsVektor[0]=Y[2];
    ZustandsVektor[1]=Y[3];
    // benötigte Werte :
    float sinDiff = sin(Y[0]-Y[1]);
    float cosDiff = cos(Y[0]-Y[1]);
    float cosProdukt = cosDiff * cosDiff;
    float s0 = sin(Y[0]);
    float s1 = sin(Y[1]);
    float alpha = - Y[3]*Y[3]*sinDiff + 2*G/L*s0 ;
    float beta = Y[2]*Y[2]*sinDiff + G/L*s1 ;
    ZustandsVektor[2]= 1 / (2-cosProdukt) * (alpha - cosDiff * beta); //Geschwindigkeit 1
    ZustandsVektor[3]= 1 / (2-cosProdukt) * (2*beta - cosDiff * alpha);//Geschwindigkeit 2 
    return ZustandsVektor;
}
////////////////////////////////////////////////////////////////////////////
void pendelUpdate(){
    // Zustand nach nächstem Zeitschritt mit Runge-Kutta 4 berechnen
    // "float[] ZVaktuell" Methode der zeitlichen Ableitung dy/dt (4-dimensional). 
    // Die DGL hängt hier nicht explizit von t ab
    //Die folgende Zeile ist Bestandteil für das Zeichnen eines Poincaré-Schnitts
     wVor = ZVaktuell[1];
    
    float[] K1 = ZVentwickeln(ZVaktuell); 
    // K2 =ZustandsVektor(t0 + dt/2, ZVaktuell + dt/2 * K1)
    float[] ZVtemp = new float[n];
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K1[i]*dt*0.5;    
    }
    float[] K2 = ZVentwickeln(ZVtemp);
    // K3 =ZustandsVektor(t0 + dt/2, ZVaktuell + dt/2 * K2)
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K2[i]*dt*0.5;
    }
    float[] K3 = ZVentwickeln(ZVtemp);
    // K4 =ZustandsVektor(t0 + dt, ZVaktuell + dt * K3)
    for (int i=0; i<n; i++) {
      ZVtemp[i] = ZVaktuell[i] + K3[i]*dt;
    }
    float[] K4 = ZVentwickeln(ZVtemp);
    // Zusammenfassung
    //  ZVaktuell = ZVaktuell + dt/6 * (K1 + 2*(K2+K3) + K4)
    for (int i=0; i<n; i++) {
      ZVaktuell[i] = ZVaktuell[i] + dt / 6.0 * (K1[i] + 2.0*(K2[i] + K3[i]) + K4[i]);
    }  
    //Die folgenden Zeilen sind Bestandteil für das Zeichnen eines Poincaré-Schnitts
     wNach = ZVaktuell[1];
    
       if(wVor < PI && wNach > PI ){
         wK = map(ZVaktuell[0],0,2*PI,0,800);  //Koordinaten der Poincaré-Schnitt Punkte 
         gK = map(ZVaktuell[2],-0.2, 0.2,500,0);   
         punkte.add(new PVector(wK,gK));
         m++; 
       }
     
    //Winkel immer zwischen 0 und 2*PI 
    if(ZVaktuell[0] > 2*PI) ZVaktuell[0] = ZVaktuell[0] - 2*PI;
    if(ZVaktuell[0] < 0)    ZVaktuell[0] = ZVaktuell[0] + 2*PI;
    if(ZVaktuell[1] > 2*PI) ZVaktuell[1] = ZVaktuell[1] - 2*PI;
    if(ZVaktuell[1] < 0)    ZVaktuell[1] = ZVaktuell[1] + 2*PI;
    W1 = ZVaktuell[0]; w1 = PI-W1;
    W2 = ZVaktuell[1]; w2 = PI-W2;
    g1= ZVaktuell[2];
    g2 = ZVaktuell[3]; 
}

////////////////////////////////////////////////////////////////////////////////
void mouseClicked() {//Neustart abwechselnd mit und ohne Spur
  
  neuStarten();
 // farbe = color(random(256),random(256),random(256));
  for(int j = 0; j<AnzahlStartpunkte;j++){
    folgePunkteBerechnen(); 
    println(j);
  }
}
////////////////////////////////////////////////////////////////////////////////
void keyPressed() {//Animation schneller/langsamer
  if (key == '+') {
    dt = dt*1.2;
  }
  if (key == '-') {
    dt = dt/1.2;
  }
}
///////////////////////////////////////////////////////////////////////////////
void neuStarten(){
  
  w1=random(-0.2,0.2);   
  W1 = PI-w1;
  w2= random(-0.2,0.2);
  W2 = PI-w2;
  //Diese Konstruktion, einmal die Winkelgeschwindigkeit g1 und ein andermal g2 zufällig zu bestimmen
  //dient dazu, dass mehrere verschieden Startpunkte im Phasendiagramm verwendet werden.
  if(random(0,1)<0.5){
  g2=random(-0.1,0.1); 
  g1 = berechneG1();
  }else{  
  g1=random(-0.1,0.1); 
  g2 = berechneG2();
  }
  ZVaktuell[0] = W1;
  ZVaktuell[1] = W2;         
  ZVaktuell[2] = g1;
  ZVaktuell[3] = g2; 
 // EKontrolleA = masse*g1*g1*L*L +0.5*masse*g2*g2*L*L + masse*g1*g2*L*L*cos(w2-w1) - G*masse*L*(2*cos(w1)+cos(w2)-3);
  m = 0;
 farbe = color(random(256),random(256),random(256));
 
}  
//////////////////////////////////////////////////////////////////////////////
void punkteZeichnen(){  
    stroke(farbe);
    strokeWeight(1);
    for(int i =0; i< punkte.size()-1 ;i++){       
        point(punkte.get(i).x,punkte.get(i).y);      
      }
    punkte.clear();
}

/////////////////////////////////////////////////////////////////////
float berechneG1(){//Damit Energie konstant ist  
  D1 = g2*g2*cos(w2-w1)*cos(w2-w1)/4 -g2*g2/2+ G*(2*cos(w1)+cos(w2)-3)/L + E/(L*L*masse);
  if(D1>=0){
    g1 = -g2*cos(w1-w2)/2 + sqrt(D1);  
  }else {
    println("Größe der Energie oder Größe der zufällig bestimmten Werte ändern!");
  }
  return g1; 
}
////////////////////////////////////////////////////////////////////
float berechneG2(){//Damit Energie konstant ist 
  D2 = g1*g1*cos(w2-w1)*cos(w2-w1) -2*g1*g1+ 2*G*(2*cos(w1)+cos(w2)-3)/L + 2*E/(L*L*masse);
  if(D2>=0){
     g2 = -g1*cos(w1-w2) + sqrt(D2);
  }else{
     println("Größe der Energie oder Größe der zufällig bestimmten Werte ändern!");
  }
  return g2; 
}
///////////////////////////////////////////////////////////////////
  
void folgePunkteBerechnen(){
  neuStarten();
  while(m<M){
      pendelUpdate();
    }
   punkteZeichnen();
}
  
  
